# -*- coding: utf-8 -*-
from gensim import corpora, similarities, models
import linecache
import jieba
import logging
import json
import requests
import sys
import copy
#　logging.basicConfig( format='%(asctime)s : %(levelname)s : %(message)s', level=logging.INFO )
# 分诊功能
from fenzhen.fenke import getKeshiNameByDesc

typedict={"img": "图片","txt": "文本","vid": "视频","url": "超链接","fil": "文件"}

flgOnlyestion = True
# 连接mysql

#dictFile,stopwordsFile,textFile,
# 导入自定义词典
jieba.load_userdict( "dict.txt" )
# read original file to analysis
# 不处理的词
fr = open( 'stopwords.txt', 'r' )
tmpstr = ""
for ln in fr:
    if tmpstr == "":
        tmpstr = ln.strip( "\n" )
    else:
        tmpstr = tmpstr + "," + ln.strip( "\n" )
stopwords = tmpstr.split( sep="," )

# 训练样本
# 从QA文件中读出问题进行训练，结果匹配答案
fr = open( "QA_all.txt", "r" )
raw_documents = []
icnt = 0
for line in fr:
    line = line.upper()
    if icnt % 2 == 0:
        raw_documents.append( line )
    icnt = icnt + 1
corpora_documents = []
for item_text in raw_documents:
    # item_str = list(jieba.cut(item_text, cut_all=False))
    item_str = []
    words1 = jieba.cut( item_text, cut_all=False )
    for lst in words1:
        if ((lst not in stopwords) and (lst.strip() != "")):
            item_str.append( lst )
    corpora_documents.append( item_str )

# 生成字典和向量语料
# 我们可以通过这些文档抽取一个“词袋（bag-of-words)"，将文档的token映射为id：
dictionary = corpora.Dictionary( corpora_documents )
dictionary.save( 'test.dict' )  # 保存生成的词典
# 加载已经保存的字典
dictionary = corpora.Dictionary()
# print(dictionary)
# dictionary.token2id用于显示单词及其id，形如：{'a': 0, 'damaged': 1, 'gold': 3, 'fire': 2, 'of': 5, 'delivery': 8, 'arrived': 7, 'shipment': 6, 'in': 4, 'truck': 10, 'silver': 9}
# print(dictionary.token2id)
dictionary = dictionary.load( 'test.dict' )
# 通过下面一句得到语料中每一篇文档对应的稀疏向量（这里是bow向量）
# 然后就可以将用字符串表示的文档转换为用id表示的文档向量：
corpus = [dictionary.doc2bow( text ) for text in corpora_documents]
# 向量的每一个元素代表了一个word在这篇文档中出现的次数
# print(corpus)
# print(corpus)结果形如：[[(0, 1), (1, 1), (2, 1), (3, 1), (4, 1), (5, 1), (6, 1)], [(0, 1), (4, 1), (5, 1), (7, 1), (8, 1), (9, 2), (10, 1)], [(0, 1), (3, 1), (4, 1), (5, 1), (6, 1), (7, 1), (10, 1)]]，例如（9，2）这个元素代表第二篇文档中id为9的单词“silver”出现了2次。
# corpora.MmCorpus.serialize('corpuse.mm',corpus)#保存生成的语料
# corpus=corpora.MmCorpus('corpuse.mm')#加载已经保存的语料
# corpus是一个返回bow向量的迭代器。下面代码将完成对corpus中出现的每一个特征的IDF值的统计工作，基于这个TF-IDF模型，我们可以将上述用词频表示文档向量表示为一个用tf-idf值表示的文档向量
tfidf_model = models.TfidfModel( corpus )
corpus_tfidf = tfidf_model[corpus]
''''' 
#查看model中的内容 
for item in corpus_tfidf: 
    print(item) 
'''''
# 保存向量
# tfidf.save("data.tfidf")
# 加载向量
# tfidf = models.TfidfModel.load("data.tfidf")
# print(tfidf_model.dfs)

similarity = similarities.Similarity( 'Similarity-tfidf-index', corpus_tfidf, num_features=4000 )

def convertresulttostdjsonobj(thelist):
    thecnt=1
    returntxt=""
    for oo in thelist:
        if returntxt=="":
            returntxt="'val"+str(thecnt)+"': "+str(oo)
        else:
            returntxt=returntxt+" ,'val"+str(thecnt)+"': "+str(oo)
        thecnt=thecnt+1
    returntxt="{ "+returntxt.replace("\'", "\"")+" }"

    return returntxt
def convertresulttojsonarray(thelist):
    thecnt=1
    returntxt=""
    for oo in thelist:
        if returntxt=="":
            returntxt=str(oo)
        else:
            returntxt=returntxt+" ,"+str(oo)
        thecnt=thecnt+1
    returntxt="[ "+returntxt.replace("\'", "\"")+" ]"

    return returntxt


def convertresult(thelist):
    thecnt=1
    returntxt=""
    for oo in thelist:
        returntxt=returntxt+"\n答案类型："+typedict[oo["type"]]+"\n"+"-"*200+"\n"+oo["content"].replace("<br>","\n　　")+"\n"+"-"*200+"\n"
        thecnt=thecnt+1
    returntxt=returntxt.replace("\'", "\"")
    return returntxt

def getfenzhenresult(msg):
    query = msg['content']  # .encode("utf-8")
    print( query )
    tmpstr2 = "推荐科室：" + getKeshiNameByDesc(query )
    print( tmpstr2 )
    returnlst=[]
    msg["type"]="txt"
    msg["content"]=tmpstr2
    returnlst.append(msg)
    return convertresult(returnlst)

def tuling_textReply(msg):
    info = msg['content'].encode( "utf-8" )
    url = "http://www.tuling123.com/openapi/api"
    data = {"key": "d035689e604d4eb891e3225116fd3ae1", "info": info, "loc": "", "userid": ""}
    apicon = requests.post( url, data ).text
    s = json.loads( apicon, encoding="utf-8" )
    print( "图灵回复", s )
    msg["type"]="txt"
    msg["content"]= s['text']
    retunlst=[]
    retunlst.append(msg)
    #return retunlst
    return convertresult(retunlst)

def WebAppInterface(msg,directText):
    if (( msg["content"][0:1]=="?") or ( msg["content"][0:1]=="？")):
        return getfenzhenresult(msg)
    print("directText=++++"+directText+"+++++++")
    linenum = -1
    # 自建索引并查询
    try:
        # 从微信传来的文本
        test_data_1 = directText
        if test_data_1 == "":
            return
        # 分词，去停用词
        test_cut_raw_1 = []
        words1 = jieba.cut( test_data_1, cut_all=False )
        for lst in words1:
            if ((lst not in stopwords) and (lst.strip() != "")):
                test_cut_raw_1.append( lst )

        # 使用LSI模型进行相似度计算
        # 有了tf-idf值表示的文档向量，我们就可以训练一个LSI模型，lsi的物理意义不太好解释，不过最核心的意义是将训练文档向量组成的矩阵SVD分解，并做了一个秩为300（取决于num_topics的值）的近似SVD分解，可以参考那篇英文tutorail。
        # on real corpora, target dimensionality of 200–500 is recommended as a “golden standard”
        # lsi = models.LsiModel(corpus_tfidf)
        # 显示Lsi模型
        # lsi.print_topics(2)
        lsi = models.LsiModel( corpus_tfidf, id2word=dictionary, num_topics=300 )
        # 有了这个lsi模型，我们就可以将文档映射到一个二维的topic空间中：
        corpus_lsi = lsi[corpus_tfidf]
        # 有了LSI模型，我们如何来计算文档直接的相似度，或者换个角度，给定一个查询Query，如何找到最相关的文档？当然首先是建索引了：
        index = similarities.MatrixSimilarity( corpus_lsi )
        # print(index)
        test_corpus_1 = dictionary.doc2bow( test_cut_raw_1 )  # 2.转换成bow向量
        # 再用之前训练好的LSI模型将其映射到二维的topic空间：
        test_corpus_tfidf_1 = tfidf_model[test_corpus_1]  # 3.计算tfidf值
        test_corpus_lsi_1 = lsi[test_corpus_tfidf_1]  # 4.计算lsi值
        # lsi.add_documents(test_corpus_lsi_1) #更新LSI的值
        # 最后就是计算其和index中doc的余弦相似度了：
        sims = index[test_corpus_lsi_1]
        # 按相似度进行排序
        tmplst = sorted( enumerate( sims ), key=lambda item: -item[1] )
        returnlist = []
        icnt = 1
        # 找出答案
        linenum = -1
        for ll in tmplst:
            # 控制返回答案数量
            if icnt > 1:
                break
            if ll[0] == 0:
                break
            # 问题对应的行号，因为格式为一行问题对应一行答案，故要＊2
            linenum = ll[0] * 2 + 1
            # 取得对应行的文本
            questionstr = linecache.getline( r'QA_all.txt', ll[0] * 2 + 1 )
            # 去掉文本的回车符
            questionstr = questionstr.strip( "\n" )
            # 将分隔符换成换行符
            questionstr = questionstr.replace( "||||", "\n" )
            # 根据答案类型来处理：txt为直接文本，img为图片，url为链接，vid为视频，fil为文件，
            linestr=linecache.getline( r'QA_all.txt', ll[0] * 2 + 2 )
            linelist=linestr.split(sep="$$$$")
            flgfirstline=True
            for tmpline in linelist:
                tmplist2=tmpline.split(sep="||||")
                if len(tmplist2)<2:
                    typestr="txt"
                    contentstr=tmplist2[0].strip("\n")
                else:
                    typestr=tmplist2[0].strip("\n")
                    contentstr=tmplist2[1].strip("\n").strip()
                tmpmsg=copy.deepcopy(msg)
                tmpmsg["type"]=typestr
                tmpmsg["content"]=contentstr
                returnlist.append(tmpmsg)
            icnt = icnt + 1
        # 如果没有找到，说明没有相关文本，由图灵机来匹配。
        if len(returnlist)==0:
            return tuling_textReply( msg )
    # itchat.send('http://www.baidu.com',msg['FromUserName'])
    except Exception:
        s = sys.exc_info()
        print( "Error '%s' happened on line %d" % (s[1], s[2].tb_lineno) )
    #return returnlist
    return convertresult(returnlist)
